"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useFetch = useFetch;

var _usePromise = require("./usePromise");

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function useFetch(path, options, specialOptions) {
  var defaultFormatter = function defaultFormatter(response) {
    if (!response.ok) {
      throw Error(response.statusText);
    }

    return response.json();
  };

  var fetchInstance = function fetchInstance(formatter) {
    return function (path, options, specialOptions) {
      var _ref = options || {},
          depends = _ref.depends,
          preventCallFetch = _ref.preventCallFetch,
          otherOptions = _objectWithoutProperties(_ref, ["depends", "preventCallFetch"]);

      if (process.env.NODE_ENV !== "production" && preventCallFetch) {
        console.warn("'preventCallFetch' is now deprecated, use 'depends' instead");
      }

      var _depends = specialOptions && specialOptions.depends || depends;

      var _preventCallFetch = _depends && _depends.reduce(function (accumulator, currentValue) {
        return accumulator || !currentValue;
      }, false) || preventCallFetch;

      if (_preventCallFetch) {
        return Promise.resolve();
      }

      return fetch(path, otherOptions).then(typeof formatter === "function" && formatter || defaultFormatter);
    };
  };

  if (options) {
    var formatter = options.formatter,
        fetchOptions = _objectWithoutProperties(options, ["formatter"]);

    return (0, _usePromise.usePromise)(fetchInstance(formatter), path, fetchOptions, specialOptions);
  } else {
    return (0, _usePromise.usePromise)(fetchInstance(), path);
  }
}